----------------------------
--le_seq_blink.vhd
----------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity le_seq_blink is
    Port ( 
        SYS_CLK : in  STD_LOGIC;
        SYS_RST : in  STD_LOGIC;
        le_timing : in STD_LOGIC;
        le : out  STD_LOGIC_VECTOR(0 to 3)
    );
end le_seq_blink;

architecture IMP of le_seq_blink is
    signal le_w : STD_LOGIC_VECTOR(0 to 3);
    signal le_tim : STD_LOGIC;
    signal le_tim_reg : STD_LOGIC;
begin
    process(SYS_CLK)
    begin
        if SYS_CLK'event and SYS_CLK = '1' then
            if SYS_RST = '1' then
                le_tim_reg <= '0';
            else
                le_tim_reg <= le_timing; 
            end if;
        end if;
    end process;
    
    process(SYS_CLK)
    begin
        if SYS_CLK'event and SYS_CLK = '1' then
            if SYS_RST = '1' then 
                le_tim <= '0';
            else
                le_tim <= le_timing and (not le_tim_reg); 
            end if;
        end if;
    end process;


    process(SYS_CLK)
    begin
        if SYS_CLK'event and SYS_CLK = '1' then
            if SYS_RST = '1' then
                le_w <= "0001";
            else
                if le_tim = '1' then
                    le_w <= le_w(1 to 3) & le_w(0);
                end if;
            end if;
        end if;
    end process;

    le <= le_w;
    
end IMP;

